unit Unit1;
{ version: voir dans la procedure TForm1.FormCreate
derniere mise a jour: 4 mai 2008
ce soft est  utiliser pour piloter l'APE2008 reli au PC par un convertisseur USB-RS232 (AVR309)
l'APE2008 contient le soft complementaire (ape2008.pas pour ATmega32 en PASCAL)
--------------------------------------------------------------------------------
Remarque concernant la liaison RS232-USB :
-Toutes les donnees sont transmises en mode texte et pas en binaire. En particulier
les nombres sont transmis chiffre (decimal) par chiffre par leur representation en
mode texte (ASCII) et non par leur valeur directe.
Ceci pour eviter des surprises lors de transmission de valeurs binaires correspondant 
des commandes (comme par exemple chr(10) ou chr(13)) qui sont la source de bugs.
--------------------------------------------------------------------------------
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Printers,
  StdCtrls, ExtCtrls, Buttons, Mask, Menus,  ShellApi, ComCtrls,
  mmsystem, Spin, Grids;

type
  TForm1 = class(TForm)
    Bt_import_CdC: TButton;
    Memo1: TMemo;
    Panel1: TPanel;
    Edit6: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Memo2: TMemo;
    Edit2: TEdit;
    Edit3: TEdit;
    Timer1_USB: TTimer;
    Timer2_Lecture_EEPROM: TTimer;
    Button1: TButton;
    Timer3_delai_1s: TTimer;
    StringGrid1: TStringGrid;
    BitBt_UP: TBitBtn;
    BitBt_DOWN: TBitBtn;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    BitBt_copie_in_grille: TBitBtn;
    Edit7: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    CBox_Constellations: TComboBox;
    Edit8: TEdit;
    Label8: TLabel;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Edit1: TEdit;
    Edit5: TEdit;
    UpDown1: TUpDown;
    Label2: TLabel;
    Edit4: TEdit;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    Edit9: TEdit;
    Edit10: TEdit;
    Panel2: TPanel;
    Etat_USB: TLabel;
    Label9: TLabel;
    Button7: TButton;
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Aide1: TMenuItem;
    Ouvrir1: TMenuItem;
    Enregistrer1: TMenuItem;
    Panel3: TPanel;
    Led_USB: TLabel;
    Label10: TLabel;
    EEPROM1: TMenuItem;
    Lire1: TMenuItem;
    Edit12: TEdit;
    Ecrire1: TMenuItem;
    Edit11: TEdit;
    Ecrire2: TMenuItem;
    StopTransfert1: TMenuItem;
    BitBtn2: TBitBtn;
    PrintDialog1: TPrintDialog;
    Imprimer1: TMenuItem;
    BitBtn3: TBitBtn;
    Edit13: TEdit;
    Label5: TLabel;
    Button8: TButton;

    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure init_RS232_USB;
    procedure decoder_CdC;
//    procedure Bt_EnvoiClick(Sender: TObject);
    procedure Bt_import_CdCClick(Sender: TObject);
    procedure constitution_message;
    procedure Envoi_Objet(cmd:string);
    procedure Menu_Init1_USBClick(Sender: TObject);
    procedure Timer1_USBTimer(Sender: TObject);
    procedure Bt_litEEPROMClick(Sender: TObject);
    procedure lire_EEPROM;
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure Edit6Change(Sender: TObject);
    procedure Timer2_Lecture_EEPROMTimer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer3_delai_1sTimer(Sender: TObject);
    procedure StringGrid1_up;
    procedure StringGrid1_down;
    procedure StringGrid1_trier(col_i:integer);
    procedure StringGrid1_tri_numerique(col_i:integer);
    procedure BitBt_UPClick(Sender: TObject);
    procedure BitBt_DOWNClick(Sender: TObject);
    procedure BitBt_copie_in_grilleClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure recopie_1ligne_dans_cadre(num_ligne:Integer);
    procedure BitBtn1Click(Sender: TObject);
    procedure Affiche_RA_sexa(nb_secondes: integer);
    procedure Affiche_DECLI_sexa(nb_secondes: integer);
    procedure StringGrid1Click(Sender: TObject);
    procedure StringGrid1_calcul_distance;
    procedure PrintGrid(const Grid: TStringGrid; const Title: string; Orientation: TPrinterOrientation);
    procedure GetZoneImpressionInPixels(PrinterHandle: HDC; var Height, Width: Integer);
    procedure OpenFichier;
    procedure Enregistrer;

    procedure Button7Click(Sender: TObject);
    procedure Ouvrir1Click(Sender: TObject);
    procedure Enregistrer1Click(Sender: TObject);
    procedure Aide1Click(Sender: TObject);
//    procedure Button8Click(Sender: TObject);
    procedure Lire1Click(Sender: TObject);
    procedure Ecrire1Click(Sender: TObject);
    procedure Ecrire2Click(Sender: TObject);
    procedure StopTransfert1Click(Sender: TObject);
    procedure StopTransfert;
    procedure BitBtn2Click(Sender: TObject);
    procedure Imprimer1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure Edit13Change(Sender: TObject);
    procedure Button8Click(Sender: TObject);

    
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
 Form1: TForm1;

implementation
{$R *.DFM}

const
  WM_USBTIMERMESSAGE = WM_USER + 401;
  NO_ERROR=0;
  DEVICE_NOT_PRESENT=1;
  NO_DATA_AVAILABLE=2;
  INVALID_BAUDRATE=3;
  OVERRUN_ERROR=4;
  INVALID_DATABITS=5;
  INVALID_PARITY=6;
  INVALID_STOPBITS=7;
  ClosedApp:boolean=false;
  PreciseTimer:integer=0;
  DLLPath='AVR309.dll';

  nbr_ast= 200;
  nb_caract_232=32;


var
  usbNoConnect:boolean;
  noReception:boolean;
  objet_valide: boolean;
  nom_fichier1:string;
  fichier_charge:boolean;
  scrutation: boolean;
  num_ligne_emise: integer;
  nocturne: boolean;
  version_i:string;
  CurrentRept:string;
  nom_Objet:string;
  nom_cstl:string;
  message1:string;
  RA, DECLI:integer;
  RAih,RAimn,RAis:integer;
  DECid,DECimn,DECis:integer;
  signeD:char;
//  RS232Buffer_in:array[1..15]of byte;
  RS232Buffer_out:array[1..50*nb_caract_232] of byte;
  RS232Buffer_in :array[1..50*nb_caract_232] of byte;
  txt_RA, txt_DECLI: string;

  function DoRS232Send(DataOutByte:byte):integer;  stdcall external DLLPath name 'DoRS232Send';
  function DoRS232Read(var DataInByte:byte):integer;  stdcall external DLLPath name 'DoRS232Read';
  function DoSetRS232Baud(BaudRate:integer):integer;  stdcall external DLLPath name 'DoSetRS232Baud';
  function DoGetRS232Baud(var BaudRate:integer):integer;  stdcall external DLLPath name 'DoGetRS232Baud';
  function DoGetRS232Buffer(var RS232Buffer:array of byte; var RS232BufferLength:integer):integer;  stdcall external DLLPath name 'DoGetRS232Buffer';
  function DoRS232BufferSend(var RS232Buffer:array of byte; var RS232BufferLength:integer):integer;  stdcall external DLLPath name 'DoRS232BufferSend';

  function DoSetRS232DataBits(DataBits:byte):integer;  stdcall external DLLPath name 'DoSetRS232DataBits';
  function DoGetRS232DataBits(var DataBits:byte):integer;  stdcall external DLLPath name 'DoGetRS232DataBits';
  function DoSetRS232Parity(Parity:byte):integer;  stdcall external DLLPath name 'DoSetRS232Parity';
  function DoGetRS232Parity(var Parity:byte):integer;  stdcall external DLLPath name 'DoGetRS232Parity';
  function DoSetRS232StopBits(StopBits:byte):integer;  stdcall external DLLPath name 'DoSetRS232StopBits';
  function DoGetRS232StopBits(var StopBits:byte):integer;  stdcall external DLLPath name 'DoGetRS232StopBits';



function GetExePath : String;
// retourne le chemin du repertoire du .exe de l'application
 var
  p1 : Integer;
  chaine1: string;
 begin
  chaine1 := Application.ExeName;  // voir "result" dclare implicitement dans l'aide
  p1:=length(chaine1);
  while (copy(chaine1, p1, 1) <> '\') and (p1>1) do dec (p1);
  Result:=copy(chaine1,1,p1);
 end;


procedure TForm1.init_RS232_USB;
var
  RetVal:integer;
begin
  try
    RetVal:=DoSetRS232Baud(19200); //(9600 ou 19200);

    RetVal:=DoSetRS232DataBits(8);
    RetVal:=DoSetRS232Parity(0);
    RetVal:=DoSetRS232StopBits(1);
    if RetVal = DEVICE_NOT_PRESENT then
     begin
      usbNoConnect:=true;
      if not(nocturne) then
      begin
       Etat_USB.Color:=clRed;
       scrutation:=false;
       Edit11.Text:='';
      end;
     end else
    begin
      usbNoConnect:=false;
      if not(nocturne) then begin Etat_USB.Color:=clLime; Etat_USB.Font.Color:=clBlack; end;
    end;
  except
  end;
end;


procedure TForm1.FormCreate(Sender: TObject);
var
 st1: string;
 i:byte;
begin
 CurrentRept:=GetExePath;
 version_i:='v2.4';
 form1.caption:='APE2008 - Importation d''objets - ' +version_i ;

 nocturne:=false;

// memoPosition:= TPosition.Create;
// memoPosition.RAZ;
// config:=TStringList.Create;

 st1:='00' + IntToStr(UpDown1.position);

 Edit5.Text:= copy(st1, length(st1) -1, 2);
 StringGrid1.ColWidths[0]:= 23;
 StringGrid1.ColWidths[1]:= 80;
 StringGrid1.ColWidths[2]:= 50;
 StringGrid1.ColWidths[3]:= 50;
 StringGrid1.ColWidths[6]:= 45;

 StringGrid1.Cells[1,0]:= 'Objet';
 StringGrid1.Cells[2,0]:= 'RA';
 StringGrid1.Cells[3,0]:= 'DECLI';
 StringGrid1.Cells[4,0]:= 'Cstl';
 StringGrid1.Cells[5,0]:= 'Mv';
 StringGrid1.Cells[6,0]:= 'num';
 For i:=1 to 200 do
  begin
   StringGrid1.Cells[0,i]:= IntToStr(i);
  end;

 init_RS232_USB;
 usbNoConnect:=true;
 noReception:=false;
 objet_valide:=false;
// portSerie.startcomm;
 fichier_charge:=false;
 scrutation:=false;
end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
 begin
  ClosedApp:=true;
  if PreciseTimer<>0 then
    begin
      timeKillEvent(PreciseTimer);
      PreciseTimer:=0;
    end;
end;


Procedure SansAccents(var s1:string);
begin
  while Pos('', s1) > 0 do s1[Pos('',s1)] := 'a';
  while Pos('', s1) > 0 do s1[Pos('',s1)] := 'a';
  while Pos('', s1) > 0 do s1[Pos('',s1)] := 'e';
  while Pos('', s1) > 0 do s1[Pos('',s1)] := 'e';
  while Pos('', s1) > 0 do s1[Pos('',s1)] := 'e';
  while Pos('', s1) > 0 do s1[Pos('',s1)] := 'e';
  while Pos('', s1) > 0 do s1[Pos('',s1)] := 'i';
  while Pos('', s1) > 0 do s1[Pos('',s1)] := 'i';
  while Pos('', s1) > 0 do s1[Pos('',s1)] := 'o';
  while Pos('', s1) > 0 do s1[Pos('',s1)] := 'u';
  while Pos('', s1) > 0 do s1[Pos('',s1)] := 'c';
end;



procedure TForm1.Affiche_RA_sexa(nb_secondes: integer);
var
  h, mn, sec      : byte;
  R1             : integer;
  signe          : string;
begin
  h:= byte(nb_secondes div 3600);
  R1:= nb_secondes mod 3600;
  mn:= byte(R1 div 60);
  sec:= byte(R1 mod 60);
  Edit9.Text:= signe + intToStr(h) + ':' + intToStr(mn) + ':' + intToStr(sec);
end;


procedure TForm1.Affiche_DECLI_sexa(nb_secondes: integer);
var
  d, mn, sec      : byte;
  R1             : integer;
  signe          : string;
begin
  if nb_secondes < 0 then begin nb_secondes := - nb_secondes; signe:= '-'; end
  else signe:= ' ';
  d:= byte(nb_secondes div 3600);
  R1:= nb_secondes mod 3600;
  mn:= byte(R1 div 60);
  sec:= byte(R1 mod 60);
  Edit10.Text:= signe + intToStr(d) + ':' + intToStr(mn) + ':' + intToStr(sec);
end;


procedure TForm1.constitution_message;
begin
 nom_Objet:=Edit6.Text + '----------';
 nom_Objet:=copy(nom_Objet, 1, 10); // le nom comporte exactement 10 caracteres (avec de '-'  la fin)
 message1:= Edit5.text +'_' + 'R' + Edit2.Text + 'D' + Edit3.Text + '_' + nom_Objet + '*'; // '*' pour contrle rception
 Edit1.Text:=message1;
 Edit4.Text:=  IntToStr(length(Edit1.Text));
end;


//========================= longue procedure ===================================
procedure TForm1.decoder_CdC;
{
Interprete le texte de la boite "Identification" du logiciel 'Cartes du Ciel' de Patrick Chevallet, v2.76
Le contenu de cette boite doit avoir t copi dans le presse papier avec le bouton "Press papiers"
de la boite "Identification" du logiciel 'Cartes du Ciel' de Patrick Chevallet.
J2000 AR:   5h46m25.83s   DE:+2204'10.9"
Date  AR:   5h46m36.37s   DE:+2204'14.4"
des mises  jour de cette procdure sont  prvoir pour rester compatible avec
les version ultrieures du logiciel 'Cartes du Ciel' de Patrick Chevallet.
(voir sur http://www.astrosurf.com/astropc pour le logiciel 'Cartes du Ciel)
Patrick Chevallet n'est en aucune manire responsable de ce proggramme (APE2008) ni de ses bugs eventuels.
C'est le type de procedure qui doit interpreter des donnees au format sens connu
mais en realite qui peut tout a fait etre totalement different de celui attendu
autrement dit il faudra la consolider d'avantage a grand renfort de "try... except..."
 Silicium628
}

var
 n, n1, i, i1, i2, L1, p1, p2, p3:integer;
 texte0, texte1, texte2, texte3, texte4, texte5, texte6:string;
 test:boolean;
begin
 try
  objet_valide:=false;
  Memo1.clear;
  RA:=0;   DECLI:=0;
  Memo1. PasteFromClipboard;
//  erreurR:=true;
//  erreurD:=true;
  signeD:='+';
  texte0:= Memo1.Lines[0];
  texte1:= Memo1.Lines[9];

  if copy(texte1,1,9)='Mouvement' then texte1:=Memo1.Lines[10];
  if ((texte0='') or (texte1='')) then
   begin
     showMessage('err:01 - Donnes dans le presse papier non conformes, pas de dcodage de coordonnes');
     RA:=0;   DECLI:=0;
     exit;
   end;
// decodage Nom Objet
  if (texte1[1] <> ' ')     // ' ' si=toile sans nom ;
  and (copy(texte0,1,7) <> 'Plante')
  and (copy(texte0,1,7) <> 'Galaxie')
  and (copy(texte0,1,9) <> 'Nbuleuse')
  and (copy(texte0,1,4) <> 'Amas')
  then
   begin
    p1:=pos(';',texte1);
    if p1>0 then Edit6.text:= copy(texte1,1,p1-1) else Edit6.text:= copy(texte1,1,12);
   end else
   begin   // si toile sans nom ou plante, copie le contenu de la 2eme ligne
    texte1:=  Memo1.Lines[1];
    p1:=pos('NGC',texte1);  // traitement de faveur pour le catalogue NGC sur le 2eme ligne

    if p1>0 then
      begin
       p3:=pos('M',texte1);  // traitement de super faveur pour les objets Messier (M13...)
       if p3>0 then Edit6.text:= copy(texte1,p3,5) else Edit6.text:= copy(texte1,p1,12)
      end  else
     begin
      texte2:= Memo1.Lines[2];
      p2:=pos('NGC',texte2);  // traitement de faveur pour le catalogue NGC sur la 3eme ligne !
      if p2>0 then Edit6.text:= copy(texte2,p2,12) else  Edit6.text:= copy(texte1,1,12);
     end;
   end;

// decodage Nom Constellation
  L1:=1;
  while  (copy (Memo1.Lines[L1],1,13) <> 'Constellation') and (L1<20)  do inc(L1);
  texte3:= Memo1.Lines[L1];
  if copy(texte3,1,13) = 'Constellation' then
   begin
    Edit7.Text:= copy(texte3,16,15);
    i1:=-1;
    n1:=4;
    texte5:= LowerCase(copy(Edit7.Text,1,n1));
    SansAccents(texte5);
    if  (texte5='peti') then begin n1:=9; texte5:= LowerCase(copy(Edit7.Text,1,n1)); SansAccents(texte5); end;
    if  (texte5='cour')then begin  n1:=15;texte5:= LowerCase(copy(Edit7.Text,1,n1)); SansAccents(texte5); end;

    while (texte4 <> texte5 ) and (i1<88) do
    begin
     inc(i1);
     CBox_Constellations.ItemIndex:=i1;
     texte4:= LowerCase(copy (CBox_Constellations.Text,1,n1));
     SansAccents(texte4);
    end;
   end
   else
    begin
     CBox_Constellations.Text:='-';
     Edit7.Text:='-';
    end;
// Decodage Magnitude
  L1:=1;
  while  (copy (Memo1.Lines[L1],1,9) <> 'Magnitude') and (L1<20)  do inc(L1);
  texte6:=Memo1.Lines[L1];
  i2:=1;
  test:=false;
  repeat
   inc(i2);
   test:= (Texte6[i2] in ['0'..'9']) or (texte6[i2]='-');
  until (test=true) or (i2=length(texte6));

  if texte6[i2] in ['0'..'9'] then Edit8.Text:= copy(texte6,i2,4);
  if texte6[i2] ='-' then Edit8.Text:= copy(texte6,i2,5);


// Recherche de RA et DEC de l'objet
  n:=0;
  repeat
   texte1:=Memo1.Lines[n];
   p1:=pos('Date',texte1);
   inc(n);
  until (p1<>0) or (n>=Memo1.Lines.Count-1);
  if p1=0 then
   begin
     showMessage('err:02 -Donnes dans le presse papier non conformes, pas de dcodage de coordonnes');
     RA:=0;   DECLI:=0;
     exit;
   end;
// donc ici p1<>0 et p1= numero de la ligne RA
// traitement ASCENSION DROITE  (RA ou AR suivant les cartes...)
// J2000 AR:   5h25m36.00s   DE:+0635'00.0"
// Date  AR:   5h25m45.98s   DE:+0635'09.2"

  p1:=pos('RA',texte1);               // detection du mot 'RA'
  if p1=0 then p1:=pos('AR',texte1);  // ou bien du mot 'AR'  (suivant les cartes...)
  if p1=0 then
   begin
    showMessage('err:03 -Donnes dans le presse papier non conformes, pas de dcodage de coordonnes');
    RA:=0;   DECLI:=0;
    exit;
   end;

   p1:=pos('RA:',texte1);             // decodage RA
   i:=p1;
   while (texte1[i]<>'h') and (i<length(texte1)) do inc(i);
   texte2:=copy(texte1,i-3,3);
   RAih:=StrToInt(texte2);
   while (texte1[i]<>'m') and (i<length(texte1)) do inc(i);
   texte2:=copy(texte1,i-2,2);
   RAimn:=StrToInt(texte2);
   while (texte1[i]<>'.') and (i<length(texte1)) do inc(i);
   texte2:=copy(texte1,i-2,2);
   RAis:=StrToInt(texte2);

// DECLINAISON
   p1:=pos('DE:',texte1);                // detection du mot 'DE'
   if p1=0 then
   begin
    showMessage('err:04 -Donnes dans le presse papier non conformes, pas de dcodage de coordonnes');
    RA:=0;   DECLI:=0;
    exit;
   end;
// decodage DEC
   p1:=pos('DE:',texte1);
   i:=p1;
   while (texte1[i]<>chr(39)) and (i<length(texte1)) do inc(i); //note: chr(39) = '
   texte2:=copy(texte1,i-6,3);
   signeD:='+'; //  priori
   if pos('-',texte2) <> 0 then  signeD:='-';
   DECid:=abs(StrToInt(texte2));  // le signe est trait sparment
                                  //  J2000 AR:   6h45m08.90s   DE:-1642'58.0"
                                  //  Date  AR:   6h45m16.73s   DE:-1643'09.5"
   texte2:=copy(texte1,i-2,2);
   DECimn:=StrToInt(texte2);
   texte2:=copy(texte1,i+1,2);
   DECis:=StrToInt(texte2);

   memo1.Lines.add(' ');

   Edit9.text:=IntToStr(RAih)+'h'+IntToStr(RAimn)+'m'+IntToStr(RAis)+'s';
   RA:= RAis + 60 * RAimn + 3600 * RAih;
   txt_RA:= '00000' + IntToStr(RA);
   txt_RA:=copy(txt_RA, length(txt_RA)-4, 5); // le string RA contient exactement 5 caracteres (avec des 0 devant)
   Edit2.Text:=txt_RA;  // affichage en secondes; plus grand affichage = '86400' (5 caract)

   Edit10.text:=IntToStr(DECid)+''+IntToStr(DECimn)+chr(39);
//   signe2.text:=signeD;
   DECLI:= DECis + 60 * DECimn + 3600 * DECid;
   if  signeD='-' then DECLI:= -DECLI;
   txt_DECLI:='0000000' +IntToStr(DECLI);  // affichage en secondes; plus grand affichage = '-324000' (7 caract)
   txt_DECLI:=copy(txt_DECLI, length(txt_DECLI)-6, 7); // le string DECLI5 contient exactement 7 caracteres (avec des 0 devant)
   Edit3.Text:=txt_DECLI;
   constitution_message;
   objet_valide:=true;
  except showmessage('err:07 - donnes non conformes');
  end;
end; // (fin de la longue procedure TForm1.decoder_CdC)
//==============================================================================


procedure OutString232(sti:string); // sortie message de longueur constante (avec des '-'  la fin le cas echeant) 
 var
  i, valeur, nb_car :integer;
begin

  for i:=1 to nb_caract_232 do  sti:=sti+'-';
  sti:=  '_' + copy(sti, 1, nb_caract_232); // le premier caractere n'est pas recu, je ne sais pas pourquoi.
  for i:=1 to nb_caract_232 do RS232Buffer_out[i]:= byte(sti[i]);
  nb_car:=nb_caract_232;  // il nous faut une variable et pas une constante pour la ligne suivante... 
  valeur:= DoRS232BufferSend(RS232Buffer_out, nb_car);
end;


procedure TForm1.Envoi_Objet(cmd:string);
begin
//  Led_USB.Color:=clyellow;
  Edit1.Text:= cmd + message1;
  try Edit4.Text:=  IntToStr(length(Edit1.Text));
  except exit;  end;
  OutString232(Edit1.Text);
end;

{
procedure TForm1.Bt_EnvoiClick(Sender: TObject);
begin
 if objet_valide then
 begin
  Envoi_Objet('!E');
//  StringGrid1.Clear;
//  Timer3_delai_1s.Enabled:=true;
//  Screen.Cursor:= crHourGlass;
 end
 else showmessage('Objet non valide');
end;
}

procedure TForm1.Bt_import_CdCClick(Sender: TObject);
begin
  decoder_CdC;
end;


procedure TForm1.Menu_Init1_USBClick(Sender: TObject);
begin
 init_RS232_USB;
end;


procedure TForm1.Timer1_USBTimer(Sender: TObject);
var BaudRate:integer;
begin
 case usbNoConnect of
 false : if DoGetRS232Baud(BaudRate)=NO_ERROR then usbNoConnect:=false else usbNoConnect:=true;
 true : init_RS232_USB;
 end;
 if usbNoConnect then Led_USB.Color:=clgray;
 //init_RS232_USB;
end;


procedure TForm1.lire_EEPROM;
var i:integer;
begin
 for i:= 1 to 950 do RS232Buffer_in[i]:=32;
 OutString232('?E');
 scrutation:=true;
end;


procedure TForm1.Bt_litEEPROMClick(Sender: TObject);
begin
 if not usbNoConnect then  lire_EEPROM else showmessage('USB non connect');
end;


procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
var
 st1:string;
begin
// ListBox1.ItemIndex:= UpDown1.position -1;
 st1:='00' + IntToStr(UpDown1.position);
 Edit5.Text:= copy(st1, length(st1) -1, 2);
 constitution_message;
end;


procedure TForm1.Edit6Change(Sender: TObject);
begin
 if objet_valide then constitution_message;
end;


procedure conversion_h_m_s(nb_secondes:integer; var h_ou_d, m, s: byte);
var
  R1             : integer;
  signe          : char;
begin
  if nb_secondes < 0 then
  begin
    nb_secondes := - nb_secondes;
    signe:= '-';
  end
  else signe:= ' ';

  h_ou_d:= nb_secondes div 3600;
  R1:= nb_secondes mod 3600;
  m:= R1 div 60;
  s:= R1 mod 60;
end;


procedure TForm1.StringGrid1_up;
// fait monter une ligne dans la liste
  var
  i:integer;
  S1:string;
 begin
  with StringGrid1 do
  begin
   if Row<2 then exit;
   for i:=1 to 6 do
   begin
    S1:= cells[i,Row];
    cells[i,Row]:= cells[i,Row-1];
    cells[i,Row-1]:=S1;
   end;
   Row:=Row-1;
  end;
end;


procedure TForm1.StringGrid1_down;
// fait descendre une ligne dans la liste
  var
  i:integer;
  S1:string;
 begin
  with StringGrid1 do
  begin
   if Row > RowCount-2 then exit;
   for i:=1 to 6 do
   begin
    S1:= cells[i,Row];
    cells[i,Row]:= cells[i,Row+1];
    cells[i,Row+1]:=S1;
   end;
   Row:=Row+1;
  end;
 end;


Function SansZero(txt_i:string):string;
var txt2:string;
begin
 txt2:= txt_i;
 if txt2<>'0' then while pos('0',txt2)=1 do txt2:= copy(txt2, 2,255); // suppression des 0 non significatifs au debut
 SansZero:=txt2;
end;


procedure TForm1.StringGrid1_tri_numerique(col_i:integer);
// tri par bulle de 6 colonnes en fonction du contenu de la colonne numero 'col_i'
// tri correctement les strings representant une valeur numerique
const
 nb_lignes=200; // nb de lignes  trier
var
 s11,s12,s21,s22,s31,s32,s41,s42,s51,s52,s61,s62:string;
 n,i:integer;
begin
  with StringGrid1 do
  begin
   for i:=1 to nb_lignes do                                 
   begin
    n:=nb_lignes-1;
    repeat
     S11:=cells[1,n];        S12:=cells[1,n+1];
     S21:=cells[2,n];        S22:=cells[2,n+1];
     S31:=cells[3,n];        S32:=cells[3,n+1];
     S41:=cells[4,n];        S42:=cells[4,n+1];
     S51:=cells[5,n];        S52:=cells[5,n+1];
     S61:=cells[6,n];        S62:=cells[6,n+1];

     if (cells[col_i,n]<>'') and (cells[col_i,n+1]<>'') then
     if StrToFloat(SansZero(cells[col_i,n])) > StrToFloat(SansZero(cells[col_i,n+1])) then
     begin
      cells[1,n+1]:=S11;    cells[1,n]:=S12;
      cells[2,n+1]:=S21;    cells[2,n]:=S22;
      cells[3,n+1]:=S31;    cells[3,n]:=S32;
      cells[4,n+1]:=S41;    cells[4,n]:=S42;
      cells[5,n+1]:=S51;    cells[5,n]:=S52;
      cells[6,n+1]:=S61;    cells[6,n]:=S62;
     end;

     n:=n-1;
    until  n<=0;
   end;
// fin du tri
  end;
end;



procedure TForm1.StringGrid1_trier(col_i:integer);
// tri par bulle de 6 colonnes en fonction du contenu de la colonne numero 'col_i'
const
 nb_lignes=200; // nb de lignes  trier
var
 s11,s12,s21,s22,s31,s32,s41,s42,s51,s52,s61,s62:string;
 n,i:integer;
begin
  with StringGrid1 do
  begin
   for i:=1 to nb_lignes do
   begin
    n:=nb_lignes-1;
    repeat
     S11:=cells[1,n];        S12:=cells[1,n+1];
     S21:=cells[2,n];        S22:=cells[2,n+1];
     S31:=cells[3,n];        S32:=cells[3,n+1];
     S41:=cells[4,n];        S42:=cells[4,n+1];
     S51:=cells[5,n];        S52:=cells[5,n+1];
     S61:=cells[6,n];        S62:=cells[6,n+1];

     if (cells[col_i,n] > cells[col_i,n+1]) then
     begin
      cells[1,n+1]:=S11;    cells[1,n]:=S12;
      cells[2,n+1]:=S21;    cells[2,n]:=S22;
      cells[3,n+1]:=S31;    cells[3,n]:=S32;
      cells[4,n+1]:=S41;    cells[4,n]:=S42;
      cells[5,n+1]:=S51;    cells[5,n]:=S52;
      cells[6,n+1]:=S61;    cells[6,n]:=S62;
     end;

     n:=n-1;
    until  n<=0;
   end;
// fin du tri
  end;
end;



procedure TForm1.StringGrid1_calcul_distance;
{calcul des distances angulaires  l'objets selectionn
ds2:=dx2 + dy2;
puis trie le tout
}
const
 nb_lignes=50;
var
 ligne0:integer;
 RAtxt, DECLItxt:string;
 RA0, RAi, DECLI0, DECLIi: real;
 i:byte;
begin
 try
   ligne0:=StringGrid1.Row;
   RA0:= StrToInt(SansZero(StringGrid1.Cells[2,ligne0]));
   DECLI0:= StrToInt(SansZero(StringGrid1.Cells[3,ligne0]));
   For i:=1 to nb_lignes do //-1 do
    begin
     RAi:= StrToInt(SansZero(StringGrid1.Cells[2,i]));
     DECLIi:=StrToInt(SansZero(StringGrid1.Cells[3,i]));
  {
  90 deg de decli  = 90*60*60 s = 324 000 s
  90 deg de RA = 6h = 6*60*60 s =  21 600 s
  Le rapport entre les deux est de 15 c.a.d qu'il faut 15s de temps pour parcourir une distance angulaire de 15 d'arc
  d'ou le coefficient ci-dessous; le 1E6 sert juste a ne pas afficher de nombres trop grands inutilement}
     StringGrid1.Cells[6,i]:= floatToStr( INT((sqr(15*(RA0-RAi)) + sqr(DECLI0-DECLIi))/1E6 ));
    end;
    except showmessage('err:06 - donnes non conformes');
  end;
  StringGrid1_tri_numerique(6);
end;


procedure TForm1.Timer2_Lecture_EEPROMTimer(Sender: TObject);
var
 nb1,i :integer;
 nom1:string;
 string_input: string;
 txt_astre:string;
 RAtxt:string;
 DECLItxt: string;
 n_ligne_txt:string;
 st1:string;
 RAh, RAm,RAs :byte;
 DECLId, DECLIm, DECLIs :byte;
begin     // RECEPTION
  
  if scrutation then
  begin
   nb1:= SizeOf(RS232Buffer_in);
   if (DoGetRS232Buffer(RS232Buffer_in,nb1)<>NO_ERROR) then
   begin
    usbNoConnect:=true;
    Exit;
   end
   else
   begin
   //  ListBox1.Clear;
     string_input:='';

    for i:= 1 to nb1 do string_input:=string_input + chr(RS232Buffer_in[i]);
    Edit12.Text:= string_input;
    if Edit12.Text='' then exit;

    Led_USB.Color:=clgreen;
    if copy(string_input,1,2)='!E' then for i:= 0 to 49 do  //reception d'une etoile
    begin
      txt_astre:= copy(string_input, i*31 +1 ,32);

      nom1:= copy(txt_astre,22,10);
      if pos('-',nom1)<>0 then nom1:=copy(nom1,1,pos('-',nom1)-1);
      StringGrid1.Cells[1,i+1]:=nom1;

      RAtxt:= copy(txt_astre,7,5);
      if RAtxt<>'' then StringGrid1.Cells[2,i+1]:=RAtxt;

      DECLItxt:= copy(txt_astre,14,7);
      if DECLItxt<>'' then StringGrid1.Cells[3,i+1]:=DECLItxt;
//      scrutation:=false;
     end;

     if copy(string_input,1,2)='?E' then  // l'ATmega32 demande l'envoi d'une etoile
      begin
        CBox_Constellations.ItemIndex:=-1;
       try
         n_ligne_txt:= copy(string_input,3,2);
         while pos('0',n_ligne_txt)=1 do n_ligne_txt:= copy(n_ligne_txt, 2,255); // suppression des 0 non significatifs au debut
         num_ligne_emise:=StrToInt(n_ligne_txt); //elle est donc determinee par l'ATmega32
         if num_ligne_emise>=50 then
         begin
          scrutation:=false;
          Led_USB.Color:=clgray;
          Panel1.Color:=clBtnFace;
          Edit11.Text:='';
         end
         else Led_USB.Color:=clyellow;
       except
         scrutation:=false;
         Edit11.Text:='erreur';
         Led_USB.Color:=clgray;
         exit;
       end;
        StringGrid1.Row:=num_ligne_emise;
        UpDown1.Position:=num_ligne_emise;
        try st1:='00' + IntToStr(UpDown1.position);
        except
         scrutation:=false;
         Edit11.Text:='';
         Led_USB.Color:=clgray;
         exit;
        end;
        Edit5.Text:= copy(st1, length(st1) -1, 2);
        recopie_1ligne_dans_cadre(num_ligne_emise);

        Envoi_Objet('!E');  // envoi de l'etoile demande
      end;

  //   ListBox1.ItemIndex:= UpDown1.position -1;

//     Screen.Cursor:= crArrow;
    end;
  end;

end;


procedure TForm1.Button1Click(Sender: TObject);
begin
 nocturne:=true;
 Form1.Color:=clBlack;
 Memo1.Color:=clBlack;
 Memo1.font.color:=clgray;
 Memo1.Ctl3D:=false;
 Memo2.Color:=clBlack;
 Memo2.font.color:=clgray;
 Panel1.Color:=clBlack;
 StringGrid1.Color:=clBlack;
 StringGrid1.font.color:=clgray;
 Etat_USB.Color:=clBlack;
 Etat_USB.Font.Color:=clgray;
 Edit1.Color:=clBlack;
 Edit1.Font.Color:=clgray;
 Edit2.Color:=clBlack;
 Edit2.Font.Color:=clgray;
 Edit3.Color:=clBlack;
 Edit3.Font.Color:=clgray;
 Edit4.Color:=clBlack;
 Edit4.Font.Color:=clgray;
 Edit5.Color:=clBlack;
 Edit5.Font.Color:=clgray;
 Edit6.Color:=clBlack;
 Edit6.Font.Color:=clgray;
 Edit7.Color:=clBlack;
 Edit7.Font.Color:=clgray;
 Edit8.Color:=clBlack;
 Edit8.Font.Color:=clgray;
 Edit10.Color:=clBlack;
 Edit10.Font.Color:=clgray;
 Edit12.Color:=clBlack;
 Edit12.Font.Color:=clgray;
 CBox_Constellations.Color:=clBlack;
 CBox_Constellations.Font.Color:=clgray;
 Edit9.Color:=clBlack;
 Edit9.Font.Color:=clgray;
end;


procedure TForm1.Timer3_delai_1sTimer(Sender: TObject);
var st1:string;
begin
 Panel1.Color:=clBtnFace;
 Led_USB.Color:=clgray;
 Edit11.Text:='';
 Timer3_delai_1s.Enabled:=false;
end;


procedure TForm1.BitBt_UPClick(Sender: TObject);
begin
 StringGrid1_up;
end;


procedure TForm1.BitBt_DOWNClick(Sender: TObject);
begin
 StringGrid1_down;
end;


procedure TForm1.Enregistrer;
var
 nom1:string;
 st1:string;
 ligne1:string;
 fichier1:TextFile;
 i:integer;
 begin
  if SaveDialog1.Execute then
   begin
    nom1:= SaveDialog1.FileName;
    if pos('.etl',nom1)=0 then nom1:=nom1+'.etl';
    AssignFile(fichier1, nom1);
    rewrite(fichier1);
{
les 2 premieres lignes sont des commentaires en entete du fichier texte sur le disque dur.
Ces commentaires ne sont pas interpretes ulterieurement par ce logiciel, qui ignore les 2 premires lignes.
}
    writeln(fichier1,'Liste d''objets astronomiques pour le logiciel APE2008');
    writeln(fichier1,'Les positions sont donnees en secondes (de temps pour RA et d''arc pour DECLI)');
{rappel:
!E06_R21336D+0026668_BETELGEUSE
}
    for i:=1 to 200 do
     begin
      st1:='00' + IntToStr(i);
      st1:= copy(st1, length(st1) -1, 2);
      nom_Objet:=StringGrid1.Cells[1,i] + '----------';
      nom_Objet:=copy(nom_Objet, 1, 10); // le nom comporte exactement 10 caracteres (avec de '-'  la fin)
      nom_cstl:= StringGrid1.Cells[4,i];
      txt_RA:= '00000' + StringGrid1.Cells[2,i];
      txt_RA:=copy(txt_RA, length(txt_RA)-4, 5);
      txt_DECLI:='0000000' + StringGrid1.Cells[3,i];
      txt_DECLI:=copy(txt_DECLI, length(txt_DECLI)-6, 7);
      ligne1:= '!E' + st1 +'_' + 'R' + txt_RA + 'D'  + txt_DECLI + '_'
      + nom_Objet +' '+ ' '+ StringGrid1.Cells[4,i]+ ' ' + StringGrid1.Cells[5,i]+ ' ' + StringGrid1.Cells[6,i];

      writeln(fichier1, ligne1);
     end;
    CloseFile(fichier1);
   end;
end;


procedure TForm1.OpenFichier;
{ lit un fichier sur le disque dur et:
-l'affiche dans StringGrid1
-le memorise dans Liste_objets1
 }
var
  fichier1:TextFile;
  ok:boolean;
  txt_ligne: string;
  i:integer;
  nom1,RAtxt,DECLItxt:string;
  RAh, RAm,RAs :byte;
  DECLId, DECLIm, DECLIs :byte;
begin
 OpenDialog1.InitialDir:=CurrentRept;
 if OpenDialog1.Execute then
 begin
  ok:=true;
//   Edit8.Text:=OpenDialog1.FileName;
  nom_fichier1:=OpenDialog1.FileName;
  AssignFile(fichier1,nom_fichier1 );
  reset(fichier1);

  readln(fichier1, txt_ligne); //ignore les 2 premieres lignes du fichier (commentaires)
  readln(fichier1, txt_ligne);
  i:=1;
  while ((not eof(fichier1)) and (i<=nbr_ast)) do
  begin
    readln(fichier1, txt_ligne);
// exemple d'une ligne conforme:  !E01_R70263D+0100719_ALBIREO---  Cyg 3.08

    if (copy(txt_ligne,1,2)<>'!E') or (txt_ligne[6]<>'R') or (txt_ligne[12]<>'D') or (txt_ligne[20]<>'_') then
      begin     // !E01_R70263D+0100719_ALBIREO---  Cyg 3.08
       txt_ligne:='!E50_R00001D+0000001_==========  === 0.01';
       ok:=false;
      end;

    StringGrid1.Cells[0,i]:=IntToStr(i);
    nom1:= copy(txt_ligne,21,10);
    if pos('-',nom1)<>0 then nom1:=copy(nom1,1,pos('-',nom1)-1);
    StringGrid1.Cells[1,i]:=nom1;
    RAtxt:= copy(txt_ligne,7,5);
//    while pos('0',RAtxt)=1 do RAtxt:= copy(RAtxt, 2,255); // suppression des 0 non significatifs au debut
    if RAtxt<>'' then StringGrid1.Cells[2,i]:=RAtxt;
    DECLItxt:= copy(txt_ligne,13,7);
//    while pos('0',DECLItxt)=1 do DECLItxt:= copy(DECLItxt, 2,255);
    if DECLItxt<>'' then StringGrid1.Cells[3,i]:=DECLItxt;
    StringGrid1.Cells[4,i]:=copy(txt_ligne,33,3);
    StringGrid1.Cells[5,i]:= copy(txt_ligne,37,4);
    StringGrid1.Cells[6,i]:= copy(txt_ligne,42,3);
    inc(i);

   end;

   CloseFile(fichier1);
   fichier_charge:=true;
   if not ok then showmessage('Certaines lignes du fichier tant non conformes, elles ont t remplaces');
 end;
end;



procedure TForm1.BitBt_copie_in_grilleClick(Sender: TObject);
{Recopie l'objet decod
-dans le StringGrid1
-dans la Liste_Objets1   
}
var
 i:byte;
 cstl1:string;
begin
 if objet_valide then
 begin
   i:=StringGrid1.Row;
   StringGrid1.Cells[1,i]:=Edit6.Text;
   StringGrid1.Cells[2,i]:= Edit2.Text;
   StringGrid1.Cells[3,i]:=Edit3.Text;
   cstl1:= CBox_Constellations.Text;
   cstl1:=copy(cstl1, length(cstl1)-2, 3);
   StringGrid1.Cells[4,i]:= cstl1;
   StringGrid1.Cells[5,i]:= Edit8.Text;
   
 end
 else showmessage('Objet non valide');
end;


procedure TForm1.Button2Click(Sender: TObject);
begin
 StringGrid1_trier(1);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 StringGrid1_trier(2);
end;


procedure TForm1.Button4Click(Sender: TObject);
begin
 StringGrid1_trier(3);
end;


procedure TForm1.Button5Click(Sender: TObject);
begin
 StringGrid1_trier(4);
end;


procedure TForm1.Button6Click(Sender: TObject);
begin
 StringGrid1_trier(5);
end;


procedure TForm1.recopie_1ligne_dans_cadre(num_ligne:integer);
var
 DECLI_txt: string;
 RA1, DECLI1 :integer;

begin
   Affiche_RA_sexa(0);
   Affiche_DECLI_sexa(0);
   Edit6.Text:=StringGrid1.Cells[1,num_ligne]; // Nom Objet
   Edit7.Text:=StringGrid1.Cells[4,num_ligne]; // Constellation
   Edit8.Text:=StringGrid1.Cells[5,num_ligne]; // Magnitude
   Edit2.Text:=StringGrid1.Cells[2,num_ligne]; // RA txt
   Edit3.Text:=StringGrid1.Cells[3,num_ligne]; // DECLI txt
   try
    RA1:= StrToInt(Edit2.Text);
    Affiche_RA_sexa(RA1);
   except objet_valide:=false; exit; end;
   
   DECLI_txt:=Edit3.Text;
   if DECLI_txt<>'0' then while pos('0',DECLI_txt)=1 do DECLI_txt:= copy(DECLI_txt, 2,255); // efface les 0 non significatifs
   try
    DECLI1:= StrToInt(DECLI_txt);
    Affiche_DECLI_sexa(DECLI1);
   except objet_valide:=false; exit; end;
   constitution_message;
   objet_valide:=true;
end;


procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  CBox_Constellations.ItemIndex:=-1;
  recopie_1ligne_dans_cadre(StringGrid1.Row);
end;

{
procedure TForm1.Envoi_liste_entiere;

begin
  CBox_Constellations.ItemIndex:=-1;
  num_ligne_emise:=0;
//  Timer3_delai_1s.Enabled:=true; // c'est le timer qui effectuera les envois.
end;
}

procedure TForm1.StringGrid1Click(Sender: TObject);
var st1:string;
begin
  UpDown1.Position:=StringGrid1.Row;
  st1:='00' + IntToStr(UpDown1.position);
  Edit5.Text:= copy(st1, length(st1) -1, 2);
  constitution_message;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
 StringGrid1_calcul_distance;
end;

procedure TForm1.Ouvrir1Click(Sender: TObject);
begin
 OpenFichier;
end;

procedure TForm1.Enregistrer1Click(Sender: TObject);
begin
 Enregistrer;
end;

procedure TForm1.Aide1Click(Sender: TObject);
begin
 Form1.FormStyle:=fsNormal; // afin qu'elle ne reste pas affiche en premier plan
 ShellExecute (handle,'Open',  PChar('Aide_APE2008.html'), PChar(''), PChar('') ,SW_SHOWNORMAL );
end;

{
procedure TForm1.Button8Click(Sender: TObject);
begin
 scrutation:=true;
end;
}

procedure TForm1.Lire1Click(Sender: TObject);
begin
  if not usbNoConnect then  lire_EEPROM else showmessage('USB non connect');
end;


procedure TForm1.Ecrire1Click(Sender: TObject);
begin
  if usbNoConnect then
   begin
    showmessage('USB non connect');
    exit;
   end;
   
  if fichier_charge then
   begin
    showmessage('Appuyez sur la touche 7 de la telecommande IR pour mettre l''APE2008 en rception'
    +chr(10) + 'puis cliquez sur ok');
    scrutation:=true;
    Edit11.Font.Color:=clgreen;
    Edit11.Text:='TRANSFERT EN COURS';
    LED_USB.Color:=clgreen;
    Panel1.Color:=clgreen;
   end
  else showmessage('Liste vide, veuillez charger un fichier');

end;


procedure TForm1.Ecrire2Click(Sender: TObject);
begin
  if usbNoConnect then
   begin
    showmessage('USB non connect');
    exit;
   end;

 if objet_valide then
 begin
  Edit11.Text:='TRANSFERT EN COURS';
  Edit11.Font.Color:=clgreen;
  Panel1.Color:=clgreen;
  Led_USB.Color:=clyellow;
  Timer3_delai_1s.Enabled:=true;
  Envoi_Objet('!E');
//  StringGrid1.Clear;
//  Timer3_delai_1s.Enabled:=true;
//  Screen.Cursor:= crHourGlass;
  
 end
 else showmessage('Cadre vide ou objet non valide' + chr(10)
 + 'Utilisez le bouton flch pour copier 1 objet de la liste dans le cadre');
end;


procedure TForm1.StopTransfert;
begin
  OutString232('!E51_R00000D0000000_----------');
  scrutation:=false;
  Led_USB.Color:=clgray;
  Panel1.Color:=clBtnFace;
  Edit11.Text:='';
end;


procedure TForm1.StopTransfert1Click(Sender: TObject);
begin
  StopTransfert;
end;


procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  StopTransfert;
end;


procedure TForm1.GetZoneImpressionInPixels(PrinterHandle: HDC; var Height, Width: Integer);
begin
  Height := GetDeviceCaps(PrinterHandle, VERTRES);
  Width := GetDeviceCaps(PrinterHandle, HORZRES);
end;


procedure TForm1.PrintGrid(const Grid: TStringGrid; const Title: string; Orientation: TPrinterOrientation);
{NOTE: cette procedure d'impression d'un StringGrid  n'est pas de moi, je l'ai touve sur Internet, sur ce site:
http://www.phidels.com/
}
var
  iLOGPIXELSX, iRow, iCol, iWidth, iHeight, X, Y, iPage : Integer;
  Rectangle1 : TRect;
  sz : String;
  bDoCenter : Boolean;

  procedure PrintTitle;
  var
    iTextW : Integer;
    szPage : String;
  begin
// Titre
    Printer.Canvas.Pen.Color  := 0;
    Printer.Canvas.Font.Name  := 'Times New Roman';
    Printer.Canvas.Font.Size  := 12;
    Printer.Canvas.Font.Style := [fsBold];
    iTextW := Printer.Canvas.TextWidth(Title);
    Printer.Canvas.TextOut((iWidth-iTextW) div 2, 100, Title);

// N de page
    Printer.Canvas.Font.Style := [];
    szPage := '- '+IntToStr(iPage)+' -';
    iTextW := Printer.Canvas.TextWidth(szPage);
    Printer.Canvas.TextOut((iWidth-iTextW) div 2, iHeight-90, szPage);

// Utilise la police de la grille (Pour l'impression des cellules)
    Printer.Canvas.Font.Name  := Grid.Font.Name;
    Printer.Canvas.Font.Size  := Grid.Font.Size;
    Printer.Canvas.Font.Style := Grid.Font.Style;
  end;

  function GetValue(const Value : Integer) : Integer;
  begin
    Result := MulDiv(Value, iLOGPIXELSX, Self.PixelsPerInch);
  end;

begin
  GetZoneImpressionInPixels(Printer.Handle, iHeight, iWidth);

// Rcupre la rsolution de l'cran
  iLOGPIXELSX := GetDeviceCaps(Printer.Handle, LOGPIXELSX);
  iPage := 1;

  Printer.Title := Title;
  Printer.BeginDoc;

// Titre
  PrintTitle;

  // Initialise le rectangle
  FillChar(Rectangle1, SizeOf(TRect), #0);
  Rectangle1.Bottom := 300;

// Parcours toutes les lignes
  for iRow := 0 to Grid.RowCount-1 do begin
    Rectangle1.Right := 200;
    Rectangle1.Top := Rectangle1.Bottom;
    Rectangle1.Bottom := Rectangle1.Top + GetValue(Grid.RowHeights[iRow]);

// Pour l'impression des titres de colonne
    bDoCenter := (iRow=0) and (Grid.FixedRows>0);

// Page suivante
    if (Rectangle1.Bottom>iHeight) then begin
      inc(iPage);
      Printer.NewPage;
      PrintTitle;
      Rectangle1.Top := 0;
      Rectangle1.Bottom := Rectangle1.Top + GetValue(Grid.RowHeights[iRow]);
    end;

// Parcours toutes les colonnes
    for iCol := 0 to Grid.ColCount-1 do begin
      // Rectangle d'impression
      Rectangle1.Left := Rectangle1.Right;
      Rectangle1.Right := Rectangle1.Left + GetValue(Grid.ColWidths[iCol]);

      // Texte  imprimer
      sz := Grid.Cells[iCol, iRow];

      // Imprime le texte
      Y := Rectangle1.Top + ((Rectangle1.Bottom-Rectangle1.Top-Printer.Canvas.TextHeight(sz)) div 2);
      if bDoCenter then X := Rectangle1.Left + ((Rectangle1.Right-Rectangle1.Left-Printer.Canvas.TextWidth(sz)) div 2)
                   else X := Rectangle1.Left+10;
      Printer.Canvas.TextRect(Rectangle1, X, Y, sz);
      Printer.Canvas.MoveTo(Rectangle1.Left, Rectangle1.Top);
      Printer.Canvas.LineTo(Rectangle1.Right, Rectangle1.Top);
      Printer.Canvas.LineTo(Rectangle1.Right, Rectangle1.Bottom);
      Printer.Canvas.LineTo(Rectangle1.Left, Rectangle1.Bottom);
      Printer.Canvas.LineTo(Rectangle1.Left, Rectangle1.Top);
    end;
  end;
  Printer.EndDoc;
end;


procedure TForm1.Imprimer1Click(Sender: TObject);
begin
  if PrintDialog1.Execute then
 begin
  PrintGrid(StringGrid1, nom_fichier1, poPortrait);
 end;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
var
 txt_ligne:string;
 i:integer;
 nom1, RAtxt, DECLItxt: string;
begin
 i:= StringGrid1.Row;
 txt_ligne:='!E50_R00001D+0000001_==========  === 0.01';

    StringGrid1.Cells[0,i]:=IntToStr(i);
    nom1:= copy(txt_ligne,21,10);
    if pos('-',nom1)<>0 then nom1:=copy(nom1,1,pos('-',nom1)-1);
    StringGrid1.Cells[1,i]:=nom1;
    RAtxt:= copy(txt_ligne,7,5);
    if RAtxt<>'' then StringGrid1.Cells[2,i]:=RAtxt;
    DECLItxt:= copy(txt_ligne,13,7);
    if DECLItxt<>'' then StringGrid1.Cells[3,i]:=DECLItxt;
    StringGrid1.Cells[4,i]:=copy(txt_ligne,33,3);
    StringGrid1.Cells[5,i]:= copy(txt_ligne,37,4);


end;

procedure TForm1.Edit13Change(Sender: TObject);
var
 i:integer;
begin
 i:=StringGrid1.row;
 StringGrid1.Cells[6,i]:= Edit13.Text;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
 StringGrid1_trier(6);
end;

END.

